package cn.com.qmth.stmms.ms.admin.exporter;

import cn.com.qmth.stmms.ms.admin.dto.PaperExpDTO;
import cn.com.qmth.stmms.ms.admin.dto.ScoreDTO;
import cn.com.qmth.stmms.ms.commons.utils.excel.ExportUtils;
import cn.com.qmth.stmms.ms.core.domain.Paper;
import cn.com.qmth.stmms.ms.core.repository.PaperRepo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * Created by yuanpan on 2017/12/23.
 */
@RestController
@RequestMapping("export/paper")
public class PaperExporter {

    @Autowired
    private PaperRepo paperRepo;

    @Value("${sys.config.imageDir}")
    private String imagesFolder;

    @GetMapping
    public void export(@RequestParam Long workId, HttpServletResponse response) {

        List<PaperExpDTO> expPapers = new ArrayList<>();
        List<Paper> allPapers = paperRepo.findByWorkId(workId);
        for (Paper paper : allPapers) {
            String filePath = imagesFolder + "/" + paper.getWorkId() + "/" + paper.getSubject().toString() + "/" + paper.getAreaCode() + "/" + paper.getExamNumber() + ".jpg";

            File file = new File(filePath);
            if (!file.exists()) {

                expPapers.add(new PaperExpDTO(paper.getStudentName(), paper.getExamNumber(), paper.getSubject().getName()));
            }

        }

        ExportUtils.exportEXCEL("错误试卷", PaperExpDTO.class, expPapers.stream().sorted((p1, p2) -> p1.getExamNumber().compareTo(p2.getExamNumber())).collect(Collectors.toList()), response);
    }
}
