package cn.com.qmth.stmms.ms.commons.config;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import java.net.InetAddress;
import java.net.UnknownHostException;

/**
 * Created by zhengmin on 2017/2/27.
 */
@Component
@ConfigurationProperties(prefix = "sys.config.imageServer")
public class ImageServerConfig {

    private String ip;
    private String port;

    public String getIp() {
        try {
            if(ip == null || ip.isEmpty()) {
               ip = InetAddress.getLocalHost().getHostAddress();

            }
        } catch (UnknownHostException e) {
            e.printStackTrace();
        }
        return ip;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    public String getPort() {
        return (port == null || port.isEmpty()) ? "3000" : port;
    }

    public void setPort(String port) {
        this.port = port;
    }

    public String getImageServer(){
        return "http://" + this.getIp() + ":" + this.getPort();
    }
}
