package cn.com.qmth.stmms.ms.core.repository;

import cn.com.qmth.stmms.ms.core.domain.ExamQuestion;
import cn.com.qmth.stmms.ms.core.vo.Subject;
import org.springframework.data.jpa.repository.JpaRepository;

import java.util.List;

/**
 * Created by zhengmin on 2016/10/9.
 */
public interface ExamQuestionRepo extends JpaRepository<ExamQuestion, Long> {

    List<ExamQuestion> findByWorkIdAndSubject(Long workId, Subject subject);

    long countByWorkIdAndTest(Long workId, int test);

    long countByWorkIdAndAreaCode(Long workId, String areaCode);

    List<ExamQuestion> findByWorkIdAndAreaCode(Long workId, String areaCode);

    ExamQuestion findByWorkIdAndSubjectAndAreaCode(Long workId,
                                                   Subject subject, String areaCode);

    ExamQuestion findByWorkIdAndSubjectAndAreaCodeAndTest(Long workId,
                                                          Subject subject, String areaCode, int test);

    void deleteByWorkId(Long workId);

    void deleteByWorkIdAndSubjectAndTest(Long workId, Subject subject, int test);

    List<ExamQuestion> findAllByAreaCodeAndSubjectAndWorkId(String areaCode, Subject subject, Long workId);

    List<ExamQuestion> findByWorkIdAndSubjectAndTest(Long workId, Subject subject, int test);
}
